<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="orderId" label="订单ID">
                <el-input-number type="number" v-model="formData.orderId"></el-input-number>
            </el-form-item>
            <el-form-item prop="target" label="投诉目标">
                <el-select v-model="formData.target" clearable filterable placeholder="请选择">
                    <el-option
                            v-for="item in targetOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="type" label="投诉类型">
                <el-input v-model="formData.type"></el-input>
            </el-form-item>
            <el-form-item prop="img" label="图片">
                <multi-upload v-model="formData.img"></multi-upload>
            </el-form-item>
            <el-form-item prop="content" label="内容">
                <el-input type="textarea" v-model="formData.content"></el-input>
            </el-form-item>
            <el-form-item prop="resolve" label="是否解决">
                <el-switch v-model="formData.resolve"></el-switch>
            </el-form-item>
            <el-form-item prop="time" label="投诉时间">
                <el-date-picker
                        v-model="formData.time"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="solution" label="解决方式">
                <el-select v-model="formData.solution" clearable filterable placeholder="请选择">
                    <el-option
                            v-for="item in solutionOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                    </el-option>
                </el-select>
                <el-button class="left" type="warning" v-if="formData.solution==='ISSUE_COUPONS'" size="mini"
                           @click="showCoupon">发放优惠券
                </el-button>
                <el-button class="left" type="warning" v-if="formData.solution==='REFUND'" size="mini">退款</el-button>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>

                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>

        <el-dialog
                title="优惠券列表"
                center
                :visible.sync="dislogTableCoupon"
        >
            <el-table :data="coupons" ref="table">
                <el-table-column align="center" type="selection"
                                 width="50">
                </el-table-column>
                <el-table-column prop="name" label="优惠券名称"></el-table-column>
                <el-table-column prop="amount" label="金额"></el-table-column>
                <el-table-column prop="fullAmount" label="限制"></el-table-column>
                <el-table-column prop="endDate" label="结束时间"></el-table-column>
            </el-table>
            <div class="pagination-wrapper">
                <el-button @click="operation1">确定</el-button>
            </div>
        </el-dialog>


        <el-dialog
                title="退款"
                center
                :visible.sync="dislogForm"
        >
            <el-form>
                <el-form-item label="商家责任">
                    <el-input></el-input>
                </el-form-item>
                <el-form-item label="骑手责任">
                    <el-input></el-input>
                </el-form-item>
            </el-form>

        </el-dialog>

    </div>
</template>
<script>
    export default {
        name: 'ComplaintEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('complaint/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {},
                rules: {},
                targetOptions: [{"label": "商家", "value": "MERCHANT"}, {"label": "骑手", "value": "RIDER"}],
                solutionOptions: [{"label": "线下沟通", "value": "OFFLINE"}, {
                    "label": "退款",
                    "value": "REFUND"
                }, {"label": "发放优惠券", "value": "ISSUE_COUPONS"}],
                dislogTableCoupon: false,
                dislogForm: false,
                coupons: [],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                data.img = data.img.join(',');
                this.$http
                    .post('/complaint/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/complaint/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
            operation1() {
                /*this.$notify({
                    title: '发放',
                    message: this.selection
                });*/
                this.$http
                    .post("/complaint/issue", {
                            id: this.id,
                            userId: this.formData.id,
                            couponId: this.selection.toString(),

                        },
                    )
                    .then(res => {
                        this.$message.success("发放成功");
                        //this.showSetLogistics = false;
                        this.$router.go(0);
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error || '发放失败');
                    });
            },
            showCoupon() {
                this.dislogTableCoupon = true;
                this.$http
                    .get('/coupon/platform')
                    .then(res => {
                        this.coupons = res.content;
                        //console.log(this.coupons)
                    })
                    .catch(e => {
                        console.log(e);
                    });
            },

        }
    }
</script>
<style lang="less" scoped>
    .left {
        margin: 0 0 0 10px;
    }
</style>
